#include <stdio.h>

#define MAXLINE 1024
#define MAXLINES 512
#define MAXFILES 16

typedef struct file_st {
  char lines[MAXLINES][MAXLINE];
  int line_count;
} file;

file files[MAXFILES];

int main(int argc,char **argv){
  int i,filei;
  FILE *fp;

  //今度そのファイルの内容を読み込んで格納したいから、
  //argv[0]はこのプログラム自体なので、
  //argv[1]から始まる：
  for(i=1;i<argc;i++){
    printf("Arg %d: %sを読み込む。。。",i,argv[i]);
    fp=fopen(argv[i],"r");
    if(!fp){ //ファイルを開けなかった場合、fpはNULLとなる
      printf("ファイル(%s)を開けませんでした。\n",argv[1]);
      continue;
    }
    file* f=files+i-1;
    for(f->line_count=0;f->line_count<MAXLINES;f->line_count++){
      if(!fgets(f->lines[f->line_count],MAXLINE,fp)) //fgetsは最後まで読み切ったらNULLを返す
	break;
    }
    printf("出来ました。\n",i,argv[i]);
  }

  //これで、全部の引数の内容を格納することができた。
  //もしやりたかったら、ファイルの中身を後で自由に使える
  int line;
  for(i=0;i<argc-1;i++){
    for(line=0;line<files[i].line_count;line++)
      printf("File %d line %3d: %s",i,line,files[i].lines[line]);
  }
}
