#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define BUFSIZE 1024 /*ファイルから読み込む一行の最大文字数*/
#define SEQ_NUMBER 30 /*一つの転写因子に対して与えられる結合部位配列の最大数*/
#define GENE_NUMBER 8 /*与えられるプロモータ領域の最大遺伝子数*/

char motif[SEQ_NUMBER][BUFSIZE]; /*転写因子の結合部位配列を保存する配列*/

struct promoter
{
  char name[BUFSIZE];
  char seq[BUFSIZE];
}pro[GENE_NUMBER];

/*遺伝子のプロモータ領域を保存する構造体*/

int read_multi_seq(char *filename)
{
  int i=0;
  FILE *fp;
  char buffer[BUFSIZE];

  if((fp=fopen(filename,"r"))==NULL) /* ファイルを開く*/
    {
      printf("scorefile open error.\n"); 
      exit(1); /*ファイルを開くことに失敗した場合終了する*/
    }
  while(fgets(buffer,sizeof(buffer),fp)!=NULL) /*ファイルから一行ずつ読み込む*/
   {
     if(buffer[strlen(buffer)-1]=='\n')
       buffer[strlen(buffer)-1]='\0'; /*改行を切り落とす*/
     strcpy(motif[i],buffer); /*結合部位配列を保存*/
     i++;
   }
  return i; /*結合部位配列の数を返す*/
}

int read_promoter(char *filename)
{
  int i=0;
  FILE *fp;
  char buffer[BUFSIZE];

  if((fp=fopen(filename,"r"))==NULL)
    {
      printf("scorefile open error.\n");
      exit(1);
    }

  while(fgets(buffer,sizeof(buffer),fp)!=NULL)
    {
      if(buffer[0]=='>')
        {
	  if(buffer[strlen(buffer)-1]=='\n')
	    buffer[strlen(buffer)-1]='\0';
          strcpy(pro[i].name,buffer+1); /*遺伝子名を保存*/
        }
      else
	{
	  if(buffer[strlen(buffer)-1]=='\n')
	    buffer[strlen(buffer)-1]='\0';
          strcpy(pro[i].seq,buffer); /*遺伝子のプロモータ領域の配列を保存*/
	  i++;
	}
    }
  return i;
}


int main(int argc,char *argv[])
{
  int i,seq_num,gene_num;
  seq_num=read_multi_seq(argv[1]); /*１番目の引数で指定した転写因子の複数の結合部位配列を読み込む*/
  printf("----in motif[]----\n");
  for(i=0;i<seq_num;i++){
    printf("%s\n",motif[i]); /*読み込んだ転写因子の結合部位配列を表示*/
  }
  printf("------------------\n");

  printf("-----in pro[]-----\n");
  gene_num=read_promoter(argv[2]); /*２番目の引数で指定した遺伝子のプロモータ領域を読み込む*/
  for(i=0;i<gene_num;i++){
    printf(">%s\n%s\n",pro[i].name,pro[i].seq); /*読み込んだプロモータ領域を表示*/
  }
  printf("------------------\n");
  return 0;
}
